#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

#include "srv.h"

int main (int argc, char *argv[])
{
	struct service service;
	char *action;

	if (argc != 3) {
		fprintf(stderr, "usage: service servicename action\n");
		exit(1);
	}

	if (service_read(argv[1], &service) < 0) {
		fprintf(stderr, "invalid service\n");
		exit(1);
	}

	if (service.script == NULL || service.script[0] == '\0') {
		fprintf(stderr, "no script defined\n");
		exit(1);
	}
	if (service.script[0] != '/') {
		fprintf(stderr, "script needs an absolute pathname\n");
		exit(1);
	}

	action = argv[2];
	if (!strcmp(action, "start")) {
		return service_start(&service);
	} else if (!strcmp(action, "stop")) {
		return service_stop(&service);
	} else if (!strcmp(action, "status")) {
		return service_status(&service);
	} else if (!strcmp(action, "restart")) {
		return service_restart(&service);
	} else if (!strcmp(action, "reload") && service.supportsreload) {
		return service_reload(&service);
	} else if (!strcmp(action, "force-reload")) {
		return service_force_reload(&service);
	} else {
		fprintf(stderr, "Invalid action. Valid actions are:\n");
		fprintf(stderr, "start stop restart %sforce-reload status\n",
		  service.supportsreload ? "reload " : "");
		exit(1);
	}
}
